////////////////////////////////////////////////////////////////////
// 
// Copyright (C) Decision Computer International Co., Ltd 
//
// # Project Name: PCI 16 Photo Isolator Input / 16 Relay Output
//                 Card VC++ 6.0 Sample (DecLib)
//
// # Used Library: Decision Library (DecLib)
//
// # Revised: WeiCheng, Tu          2005/06/18
//        @ Add comments
//        @ Fix the bug that on Release Mode, delay doesn't
//          work well.    
//
////////////////////////////////////////////////////////////////////

// Test16P16RDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test16P16R.h"
#include "Test16P16RDlg.h"
#include "Dii.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest16P16RDlg dialog

CTest16P16RDlg::CTest16P16RDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest16P16RDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTest16P16RDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest16P16RDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTest16P16RDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX ,IDC_BUTTON1,msg1 );
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTest16P16RDlg, CDialog)
	//{{AFX_MSG_MAP(CTest16P16RDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
	ON_COMMAND_RANGE(IDC_CHECK1,IDC_CHECK16,OnBitToggled)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTest16P16RDlg message handlers

BOOL CTest16P16RDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	BOOL init;
	BOOL temp;
	unsigned short byState;
	char DevName[200];
	CString str;

    init = DiiSelectDevice(NULL, DevName, 210);

	if (init == false)
		msg1.SetWindowText("Can't find the port!");
	
	hDevice = DiiOpenNamedDevice(DevName, true);	

	if (hDevice != INVALID_HANDLE_VALUE){
		msg1.SetWindowText( "Get card address success !!");
		temp = DiiSetDigitalWord(hDevice, 0, 0);
		temp = DiiGetDigitalWord(hDevice, 0, &byState);
	}
	else{
		msg1.SetWindowText( "Get card address fail !!");
	}

	m_nTimer = SetTimer (1, 1, 0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTest16P16RDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTest16P16RDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CTest16P16RDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CTest16P16RDlg::OnOK() 
{
	//CloseDevice (m_usPortAddress);
	KillTimer (m_nTimer);	
	CDialog::OnOK();
}

void CTest16P16RDlg::OnCancel() 
{
//	CloseDevice (m_usPortAddress);
	KillTimer (m_nTimer);
	CDialog::OnCancel();
}

//
// This function is called, whenever the user has clicked on one
// of the output line buttons
//
void CTest16P16RDlg::OnBitToggled(UINT idButton)
{
	BOOL bState = IsDlgButtonChecked (idButton);
	DWORD dwBit = idButton - IDC_CHECK1;
	USHORT utemp=0, uctemp = 0;

	//
	// initilize all buttons
	//
	for(DWORD bitCnt = 0; bitCnt < 15; bitCnt++)
	{
		if(bitCnt != dwBit)
			CheckDlgButton (IDC_CHECK1 + bitCnt, FALSE);
	}

	//
	// calculate the output value (check box ID --> real output value)
	//
	if(bState)  // if checked (bit set to 1)
	{
		uctemp = 1;
		uctemp = uctemp << dwBit;
	}
	else        // if unchecked (bit clear to 0)
		uctemp = 0;

	//
	// output to device. If unsuccessfully, restore the state of the output button
	//
	if (!DiiSetDigitalWord(hDevice , 0 , uctemp))
		
		CheckDlgButton (idButton,FALSE);
}

//
// input from device and show the results (real input value --> check box ID)
//
void CTest16P16RDlg::OnTimer(UINT nIDEvent) 
{
	
	unsigned short utemp ,ubit;
	

	DiiGetDigitalWord(hDevice , 0 , &utemp);
	
	//
	// show the result
	//
	for (int bitCnt2 = 0; bitCnt2 < 16; bitCnt2++)
	{	
		ubit = utemp >> bitCnt2;
		ubit = ubit & 0x01;
		if (ubit)
			CheckDlgButton(IDC_CHECK17 + bitCnt2, BST_CHECKED);   // 1
		else
			CheckDlgButton(IDC_CHECK17 + bitCnt2, BST_UNCHECKED); // 0
	}
	
	CDialog::OnTimer(nIDEvent);
}
